/*
 * game.h
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 */
#ifndef JK_GAME_H
#define JK_GAME_H

#include "thread.h"
#include "game_world.h"
#include "game_object.h"
#include "sample_msg.h"
#include "screen_msg.h"

#define KEY_NUM		4

class Game {
	public:
		Game(SampleFifo *in_fifo, ScreenFifo *out_fifo, int height = 20, int width = 74);
		~Game(void);

		void main(void);
		void kill(void);

	private:
		typedef struct {
			int min, max;
			char symbol;
		} KeyBound;
		
		static const KeyBound key_bound[KEY_NUM];

		void sample2keys(int key[KEY_NUM], SampleMsg *msg, int clear);
		
		int world_height, world_width;
		volatile int main_done;
		SampleFifo *in_fifo;
		ScreenFifo *out_fifo;

};

#endif
