/*
 * game_ground.h
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 */
#ifndef JK_GAME_GROUND_H
#define JK_GAME_GROUND_H

#include "game_object.h"

/*****************************************************************************
 * GGround -- Povrch, pozadi
 */
class GGround : public GObject {
	public:
		virtual void step(void) { return; };
		bool is_accessible(void) { return accessibility; };
	
	protected:
		bool accessibility;
};

/*****************************************************************************
 * GTrava -- normalni pozadi
 */
class GTrava : public GGround {
	public:
		GTrava(void) {
			name = "Trava"; 
			goid = GOID_TRAVA;
			accessibility = true;
			damage = 0;
			add_property(GOP_DAMAGE, &damage);
		};
		void step(void);
		GSymbol* draw(void);

	private:
		int damage;
};


/*****************************************************************************
 * GVoda -- nepruchodne pozadi
 */
class GVoda : public GGround {
	public:
		GVoda(void) {
			name = "Voda";
			goid = GOID_VODA;
			accessibility = false;
		};
		GSymbol* draw(void) {
			return new GSymbol(goid, '~', 4, pos_x, pos_y, pos_z);
		};
};


/*****************************************************************************
 * GCesta -- neprohrabatelne pozadi, zahradnik je rychlejsi
 */
class GCesta : public GGround {
};

#endif
