/*
 * game_item.h
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 */
#ifndef JK_GAME_ITEM_H
#define JK_GAME_ITEM_H

#include "game_object.h"

/*****************************************************************************
 * GItem -- stacionarni blbosti
 */
class GItem : public GObject {
	public:
};

/*****************************************************************************
 * GKyticka -- kyticka, zahradnikuv poklad
 */
class GKyticka : public GItem {
	public:
		GKyticka(void) {
			name = "Kyticka";
			goid = GOID_KYTICKA;
			age = 0;
			stage = 0;
		};
		GSymbol* draw(void) {
			static const char *sym = ".;*@Oo";
			return new GSymbol(goid, sym[stage], 13, pos_x, pos_y, pos_z);
		};
		void step(void);
	private:
		int age;
		int stage;
};


/*****************************************************************************
 * GZizala -- zizala, krmeni pro krtka
 */
class GZizala : public GItem {
};


/*****************************************************************************
 * GKrtinec -- transportni zarizeni pro krtka
 */
class GKrtinec : public GItem {
};

#endif
