////////////////////////////////////////////////////////////////
//                                                            //
// glutMaster.c++                                             //
// beta version 0.3 - 9/9/97)                                 //
//                                                            //
// George Stetten and Korin Crawford                          //
// copyright given to the public domain                       //
//                                                            //
// Modified by Josef Kufner <jk@myserver.cz>                  //
//                                                            //
//                                                            //
////////////////////////////////////////////////////////////////

#include "glut_master.h"
#include "glut_window.h"
#include <time.h>
#include <stdio.h>

#define DEBUG 0
#include "debug.h"

GlutWindow * viewPorts[MAX_NUMBER_OF_WINDOWS]; 

int GlutMaster::currentIdleWindow = 0;
int GlutMaster::idleFunctionEnabled = 0;


GlutMaster::GlutMaster(int *argc, char *argv[]){
	DBG_MSG(5, "");

	// Create dummy variables 
/*
	char * dummy_argv[1];
	dummy_argv[0] = "run";
	int dummy_argc = 1;
*/
	// Initialize GLUT

	glutInit(argc, argv);
}

GlutMaster::~GlutMaster(){
	DBG_MSG(5, "");

}
 
void GlutMaster::CallBackDisplayFunc(void){
	DBG_MSG(5, "");


	int windowID = glutGetWindow();
	viewPorts[windowID]->CallBackDisplayFunc();
}

void GlutMaster::CallBackIdleFunc(void){
	DBG_MSG(5, "");
	if(idleFunctionEnabled && currentIdleWindow){
		int old_win = glutGetWindow();
		glutSetWindow(currentIdleWindow);
		viewPorts[currentIdleWindow]->CallBackIdleFunc();
		glutSetWindow(old_win);
	}
}
 
void GlutMaster::CallBackKeyboardFunc(unsigned char key, int x, int y){
	DBG_MSG(5, "");

	int windowID = glutGetWindow();
	viewPorts[windowID]->CallBackKeyboardFunc(key, x, y);
}

void GlutMaster::CallBackMotionFunc(int x, int y){
	DBG_MSG(5, "");

	int windowID = glutGetWindow();
	viewPorts[windowID]->CallBackMotionFunc(x, y);
}

void GlutMaster::CallBackMouseFunc(int button, int state, int x, int y){
	DBG_MSG(5, "");

	int windowID = glutGetWindow();
	viewPorts[windowID]->CallBackMouseFunc(button, state, x, y);
}

void GlutMaster::CallBackPassiveMotionFunc(int x, int y){
	DBG_MSG(5, "");

	int windowID = glutGetWindow();
	viewPorts[windowID]->CallBackPassiveMotionFunc(x, y);
}

void GlutMaster::CallBackReshapeFunc(int w, int h){
	DBG_MSG(5, "");

	int windowID = glutGetWindow();
	viewPorts[windowID]->CallBackReshapeFunc(w, h);
}

void GlutMaster::CallBackSpecialFunc(int key, int x, int y){
	DBG_MSG(5, "");

	int windowID = glutGetWindow();
	viewPorts[windowID]->CallBackSpecialFunc(key, x, y);
}	

void GlutMaster::CallBackVisibilityFunc(int visible){
	DBG_MSG(5, "");

	int windowID = glutGetWindow();
	viewPorts[windowID]->CallBackVisibilityFunc(visible);
}

void GlutMaster::CallGlutCreateWindow(char * setTitle, GlutWindow * glutWindow){
	DBG_MSG(5, "");

	// Open new window, record its windowID , 

	int windowID = glutCreateWindow(setTitle);

	glutWindow->SetWindowID(windowID);

	// Store the address of new window in global array 
	// so GlutMaster can send events to propoer callback functions.

	viewPorts[windowID] = glutWindow;

	// Hand address of universal static callback functions to Glut.
	// This must be for each new window, even though the address are constant.
	// 
	glutDisplayFunc(CallBackDisplayFunc);
	//glutIdleFunc(CallBackIdleFunc); 
	glutKeyboardFunc(CallBackKeyboardFunc);
	glutMouseFunc(CallBackMouseFunc);
	glutMotionFunc(CallBackMotionFunc);
	glutPassiveMotionFunc(CallBackPassiveMotionFunc);
	glutSpecialFunc(CallBackSpecialFunc);
	glutReshapeFunc(CallBackReshapeFunc); 
	glutVisibilityFunc(CallBackVisibilityFunc);

}

void GlutMaster::CallGlutMainLoop(void){
	DBG_MSG(5, "");

	glutMainLoop();
}
										
void GlutMaster::DisableIdleFunction(void){
	DBG_MSG(5, "");

	idleFunctionEnabled = 0;
	glutIdleFunc(0); 
}

void GlutMaster::EnableIdleFunction(void){
	DBG_MSG(5, "");

	idleFunctionEnabled = 1;
	glutIdleFunc(CallBackIdleFunc); 
}

int GlutMaster::IdleFunctionEnabled(void){
	DBG_MSG(5, "");

	// Is idle function enabled?
	return(idleFunctionEnabled);
}

int GlutMaster::IdleSetToCurrentWindow(void){
	DBG_MSG(5, "");

	// Is current idle window same as current window?

	return( currentIdleWindow == glutGetWindow() );
}

void GlutMaster::SetIdleToCurrentWindow(void){
	DBG_MSG(5, "");
	currentIdleWindow = glutGetWindow();
}

