/*
 * sample.h
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 */
#ifndef JK_SAMPLE_H
#define JK_SAMPLE_H

#include "thread.h"
#include "fft.h"
#include "fifo.h"
#include "sample_msg.h"

class Sample : Thread {
	public:
		Sample(SampleFifo *fifo);
		~Sample(void);
		void *main(void);

	private:
		SampleFifo *fifo;
		int finish;
		pthread_t th;
		int audio_fd;
		
		int open_audio(char *audio_device = "/dev/audio");
		int read_audio(sound_sample *buf, int buf_size);
		int close_audio(void);
		int scan_freq(char *buf);
};

#endif
