/*
 * screen.h
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */
#ifndef JK_SCREEN_H
#define JK_SCREEN_H

#include <list>

#include "fifo.h"
#include "lock.h"
#include "ref.h"

class ScreenFreqRule : public Lock, public Ref {
	public:
		ScreenFreqRule(void){
			rule_i = rule.begin();
		};

		void add(float f, float t, char l) {
			struct s_freq_label *n = new s_freq_label;
			n->from = f;
			n->to = t;
			n->label = l;
			rule.push_back(n);
		};
		
		bool get(float *f, float *t, char *l) {
			if (rule_i != rule.end()) {
				*f = (*rule_i)->from;
				*t = (*rule_i)->to;
				*l = (*rule_i)->label;
				rule_i++;
				return true;
			} else {
				return false;
			}
		}
		void get_rewind(void) {
			rule_i = rule.begin();
		}

		bool empty(void) {
			return rule.empty();
		}
	
	private:
		struct s_freq_label {
			float from, to; 
			char label;
		};
		typedef std::list<s_freq_label *> Rule;

		Rule rule;
		Rule::iterator rule_i;

};

#endif

