/*
 * thread.cc
 * 
 * Copyright (C) 2005  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * 
 */

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <strings.h>

#include "thread.h"

#define CLASS "Thread"
#define DEBUG_PREFIX_STR	"%s%s"
#define DEBUG_PREFIX_ARG	name, name[0] ? ": " : ""
#define DEBUG 2
#include "debug.h"


Thread::Thread(char *name, bool launch_later) {
	this->name = strdup(name);
	DBG_MSG(1, "Initializing...");
	
	if (!launch_later) {
		/* create sound sampling thread */
		is_launched = true;
		pthread_create(&thread, NULL, exec_thread, this);
	} else {
		is_launched = false;
	}
	
	/* say bye */
	DBG_MSG(2, "Done.");

	return;	
}

Thread::~Thread(void) {
	DBG_MSG(1, "Cleaning up...");

	/* wait until thread finishes */
	pthread_join(thread, NULL);
	
	DBG_MSG(2, "Done.");
	return;
}

void Thread::thread_launch(void) {
	DBG_MSG(1, "");
	is_launched = true;
	pthread_create(&thread, NULL, exec_thread, this);
	DBG_MSG(1, "Done");
}

const char *Thread::get_thread_name(void) {
	return name;
}
